diff --git a/t3lib/file/class.t3lib_file_Repository.php b/t3lib/file/class.t3lib_file_Repository.php
new file mode 100644
index 0000000..f6a7859
--- /dev/null
+++ t3lib/file/class.t3lib_file_Repository.php
@@ -0,0 +1,156 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+class t3lib_file_Repository implements t3lib_Singleton {
+
+	/**
+	 * Get the file by ID
+	 *
+	 * @param integer UID of the file record
+	 * @return t3lib_file_File A file object instance
+	 */
+	public function getFileById($uid) {
+		$recordData = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*', 'sys_files', 'uid=' . $uid);
+		$mount = $this->getMountForFile($recordData);
+
+		if (count($recordData) == 0) {
+			throw new t3lib_file_exception_FileNotFound();
+		}
+
+		return new t3lib_file_File($mount, $recordData[0]);
+	}
+
+	/**
+	 * 
+	 */
+	public function getFilesFromRelation($field, $table, $recordUid) {
+		if(TYPO3_MODE === 'FE') { // @TODO: Check if constant name and value TYPO3_MODE === 'FE' are correct for checking for FE.
+			$GLOBALS['TSFE']->includeTCA();
+		}
+		t3lib_div::loadTCA($table);
+
+		$assetObjects = array();
+
+		// get column definition
+		$MMfieldTCA = $GLOBALS['TCA'][$table]['columns'][$field]['config'];
+
+		$dbGroup = t3lib_div::makeInstance('t3lib_loadDBGroup');
+		$dbGroup->start($recordUid, 'sys_files', $MMfieldTCA['MM'], intval($recordUid), $table, $MMfieldTCA);
+		$assetIds = $dbGroup->tableArray['sys_files'];
+		if (is_array($assetIds)) {
+			foreach ($assetIds as $key => $uid) {
+				$assetObjects[] = $this->getFileById($uid);
+			}
+		}
+		return $assetObjects;
+	}
+
+	/**
+	 * Returns a file object by the file's complete path.
+	 *
+	 * @param string $filePath The path to the file. May contain the alias of the mount if this is not given as the second parameter.
+	 * @param t3lib_file_Mount $mount The mount the file is located in (optional). If this is not given, the mount is extracted from the first part of the path.
+	 * @return t3lib_file_File
+	 *
+	 * @throws t3lib_file_exception_FileNotFound
+	 *
+	 * TODO: respect file mount (extract it from the path or take it as parameter - both ways should be supported)
+	 */
+	public function getFileByPath($filePath, $mount = NULL) {
+		if ($mount == NULL) {
+			$pathParts = explode('/', $filePath, 2);
+			$mountAlias = array_shift($pathParts);
+			$mount = t3lib_file_Mount::getInstanceForAlias($mountAlias);
+		}
+
+		$fileName = substr($filePath, strrpos($filePath, '/') + 1);
+		$folderPath = substr($filePath, 0, strrpos($filePath, '/') + 1);
+
+		$recordData = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*', 'sys_files',
+			'file_path = "' . $folderPath . '" AND file_name = "' . $fileName . '" AND mount = ' . intval($mount->getUid));
+
+		if (count($recordData) == 0) {
+			throw new t3lib_file_exception_FileNotFound();
+		}
+		$mount = $this->getMountForFile($recordData);
+
+		return new t3lib_file_File($mount, $recordData[0]);
+	}
+
+	/**
+	 * Returns all files that are related to a certain field in a certain record.
+	 *
+	 * @param string $table The table
+	 * @param integer $recordUid The record uid
+	 * @param string $fieldName The field name
+	 * @param string $structurePath The structure path in FlexForm data inside $field (optional)
+	 * @return array
+	 *
+	 * TODO: define what is returned by this method (a list of file uids or complete file records)
+	 */
+	public function getReferencedFilesForRecordField($table, $recordUid, $fieldName, $structurePath = '') {
+		//
+	}
+
+	/**
+	 * Returns the mount record for a specified file.
+	 *
+	 * @param array $fileRecord
+	 * @return void
+	 */
+	protected function getMountForFile(array $fileRecord) {
+		$mount = $fileRecord['mount'];
+
+		return t3lib_file_Mount::getInstanceForUid($mount);
+	}
+
+	/**
+	 * @throws t3lib_file_exception_FileNotFound
+	 * @param  $filePath
+	 * @return array
+	 *
+	 * TODO: respect file mount (extract it from the path or take it as parameter - both ways should be supported)
+	 */
+	public function getAllInPath($filePath) {
+		$recordData = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*', 'sys_files',
+			'file_path = "' . $filePath . '"');
+
+		if (count($recordData) == 0) {
+			throw new t3lib_file_exception_FileNotFound();
+		}
+		$mount = $this->getMountForFile($recordData[0]);
+
+		$files = array();
+		foreach ($recordData as $data) {
+			$files[] = new t3lib_file_File($mount, $data);
+		}
+
+		return $files;
+	}
+}
+
+?>
diff --git a/t3lib/file/exception/class.t3lib_file_exception_filenotfound.php b/t3lib/file/exception/class.t3lib_file_exception_filenotfound.php
new file mode 100644
index 0000000..418e4b4
--- /dev/null
+++ t3lib/file/exception/class.t3lib_file_exception_filenotfound.php
@@ -0,0 +1,4 @@
+<?php
+
+class t3lib_file_exception_FileNotFound extends RuntimeException {
+}
\ No newline at end of file
diff --git a/t3lib/file/storage/class.t3lib_file_storage_filesystemstorage.php b/t3lib/file/storage/class.t3lib_file_storage_filesystemstorage.php
new file mode 100644
index 0000000..460f93d
--- /dev/null
+++ t3lib/file/storage/class.t3lib_file_storage_filesystemstorage.php
@@ -0,0 +1,141 @@
+<?php
+
+class t3lib_file_storage_FileSystemStorage implements t3lib_file_storage_Interface {
+
+	/**
+	 * @var array The configuration for this backend
+	 */
+	protected $configuration;
+
+	/**
+	 * @var string
+	 */
+	protected $basePath;
+
+	/**
+	 * @param array $configuration The configuration for the backend
+	 */
+	public function __construct($configuration) {
+		$this->configuration = $configuration;
+
+		if ($configuration['relative']) {
+			$this->basePath = t3lib_div::resolveBackPath(PATH_site . $configuration['path']);
+		} else {
+			$this->basePath = $configuration['path'];
+		}
+		$this->basePath = rtrim($this->basePath, '/') . '/';
+
+		// TODO: throw exception if $this->basePath does not exist
+	}
+
+	public function read($path) {
+		return file_get_contents($path);
+	}
+
+	public function write($path, $content) {
+		return file_put_contents($path, $content);
+	}
+
+	public function delete($path) {
+		if ($this->exists($path)) {
+			unlink($path);
+		}
+	}
+
+	public function exists($path) {
+		return file_exists($path);
+	}
+
+	public function getModificationTime($path) {
+		if ($this->exists($path)) {
+			return filemtime($path);
+		}
+	}
+
+	public function getFileHash($path) {
+		if ($this->exists($path)) {
+			return sha1_file($path);
+		}
+	}
+
+	public function getSize($path) {
+		if ($this->exists($path)) {
+			return filesize($path);
+		}
+	}
+
+	public function getBasePath() {
+		return $this->basePath;
+	}
+
+	public function getBaseUrl() {
+		if ($this->configuration['relative']) {
+			return $this->configuration['path'];
+		}
+	}
+
+	public function open($path, $mode) {}
+
+	/**
+	 * Copies a file inside this storage. All parameters are relative to the base of this storage
+	 *
+	 * @param  $path
+	 * @param  $newPath
+	 * @return void
+	 */
+	public function copyFile($path, $newPath) {
+		$path = $this->basePath . $path;
+		$newPath = $this->basePath . $newPath;
+		if (!file_exists($path)) {
+			throw new InvalidArgumentException('Source file does not exist.');
+		}
+
+		if (!copy($path, $newPath)) {
+			throw new RuntimeException("Copying file '$path' to '$newPath' failed.");
+		}
+	}
+
+	/**
+	 * Moves a file inside this storage.
+	 *
+	 * @param string $oldPath The file to move
+	 * @param string $newPath The location to move to
+	 * @return void
+	 *
+	 * @throws InvalidArgumentException If the file does not exist or there is a file at the new location
+	 */
+	public function moveFile($oldPath, $newPath) {
+		$oldPath = $this->basePath . $oldPath;
+		$newPath = $this->basePath . $newPath;
+
+		if (!file_exists($oldPath)) {
+			throw new InvalidArgumentException('Source file does not exist.');
+		}
+		if (file_exists($newPath)) {
+			throw new InvalidArgumentException('Target file already exists.');
+		}
+
+		rename($oldPath, $newPath);
+	}
+
+	/**
+	 * Creates a directory inside a path
+	 *
+	 * @return boolean
+	 */
+	public function createDirectory($path, $directoryName) {
+		$path = rtrim($this->basePath . $path, '/') . '/';
+
+		return mkdir($path . $directoryName);
+	}
+
+	/**
+	 * Returns a list of all files and directories inside a path
+	 *
+	 * @param string $path
+	 * @return void
+	 */
+	public function getListing($path) {}
+}
+
+?>
\ No newline at end of file
diff --git a/t3lib/file/storage/interface.t3lib_file_storage_interface.php b/t3lib/file/storage/interface.t3lib_file_storage_interface.php
new file mode 100644
index 0000000..cac26ba
--- /dev/null
+++ t3lib/file/storage/interface.t3lib_file_storage_interface.php
@@ -0,0 +1,118 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+interface t3lib_file_storage_Interface {
+	public function getBasePath();
+
+	public function getBaseUrl();
+
+	public function open($path, $mode);
+
+	/**
+	 * Read the contents of a file
+	 *
+	 * @param		string		Absolute path to the file
+	 * @return		string		File contents
+	 */
+	public function read($path);
+
+	/**
+	 * Write data into a file
+	 *
+	 * @param		string		Absolute path to the file
+	 * @param		string		File contents
+	 * @return		boolean		Success of operation
+	 */
+	public function write($path, $content);
+
+	/**
+	 * Delete the file
+	 *
+	 * @param		string		Absolute path to the file
+	 * @return		void
+	 */
+	public function delete($path);
+
+	/**
+	 * Check if file or directory exists
+	 *
+	 * @param		string		Absolute path to the file
+	 * @return		boolean		True if the file or folder exists, false otherwise
+	 */
+	public function exists($path);
+
+	/**
+	 * Get timestamp of when the file was last modified
+	 *
+	 * @param		string		Absolute path to the file
+	 * @return		integer		Timestamp
+	 */
+	public function getModificationTime($path);
+
+	/**
+	 * Get the sha1 hash of the file
+	 *
+	 * @param		string		Absolute path to the file
+	 * @return		string		Hash of the content
+	 */
+	public function getFileHash($path);
+
+	/**
+	 * Get the file size of the content
+	 *
+	 * @param		string		Absolute path to the file
+	 * @return		integer		Size of the file in bytes
+	 */
+	public function getSize($path);
+
+	/**
+	 * Copies a file inside this storage. All parameters are relative to the base of this storage
+	 *
+	 * @param  $path
+	 * @param  $newPath
+	 * @return void
+	 */
+	public function copyFile($path, $newPath);
+
+	public function moveFile($oldPath, $newPath);
+
+	/**
+	 * Creates a directory inside a path
+	 *
+	 * @return boolean TRUE if the directory could be created
+	 */
+	public function createDirectory($path, $directoryName);
+
+	/**
+	 * Returns a list of all files and directories inside a path
+	 *
+	 * @param string $path
+	 * @return void
+	 */
+	public function getListing($path);
+}
+?>
diff --git a/t3lib/file_bak_Andreas/class.t3lib_file_file.php b/t3lib/file_bak_Andreas/class.t3lib_file_file.php
new file mode 100644
index 0000000..30670b0
--- /dev/null
+++ t3lib/file_bak_Andreas/class.t3lib_file_file.php
@@ -0,0 +1,76 @@
+<?php
+
+/**
+ * The file class of the TYPO3 File Abstraction Layer
+ */
+class t3lib_file_File {
+	
+	/**
+	 * The uid of this node
+	 *
+	 * @var integer
+	 */
+	protected $uid;
+
+	/**
+	 * The name of this node. This is only the name on the current leve, no path
+	 *
+	 * @var string
+	 */
+	protected $name;
+
+	/**
+	 * The parent node of this node
+	 *
+	 * @var t3lib_file_Mount
+	 */
+	protected $mount;
+
+	/**
+	 * The path to this file (inside the file mount)
+	 *
+	 * @var string
+	 */
+	protected $path = NULL;
+
+	/**
+	 * The file size
+	 * 
+	 * @var integer
+	 */
+	protected $size;
+
+	/**
+	 * The hash sum of the file
+	 * TODO: decide on a hashing algorithm
+	 *
+	 * @var string
+	 */
+	protected $hash;
+
+	public function __construct($fileData) {
+		$this->uid = $fileData['uid'];
+		$this->name = $fileData['name'];
+		$this->path = $fileData['path'];
+		$this->size = $fileData['size'];
+	}
+
+	public function getUid() {
+		return $this->uid;
+	}
+
+	public function getName() {
+		return $this->name;
+	}
+
+	public function getPath() {
+		return $this->path;
+	}
+
+	public function getSize() {
+		return $this->size;
+	}
+
+}
+
+?>
\ No newline at end of file
diff --git a/t3lib/file_bak_Andreas/class.t3lib_file_repository.php b/t3lib/file_bak_Andreas/class.t3lib_file_repository.php
new file mode 100644
index 0000000..8ae05a9
--- /dev/null
+++ t3lib/file_bak_Andreas/class.t3lib_file_repository.php
@@ -0,0 +1,66 @@
+<?php
+
+/**
+ * Repository class for files.
+ *
+ * @TODO add support for file mounts
+ *
+ */
+class t3lib_file_Repository {
+	/**
+	 * @static
+	 * @throws t3lib_file_exception_FileNotFound
+	 * @param  integer $uid
+	 * @return t3lib_file_File
+	 *
+	 * @TODO define how to handle more than one match (which would point to an error in the database structure)
+	 */
+	public static function getByUid($uid) {
+		$recordData = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*', 'sys_files', 'uid=' . $uid);
+
+		if (count($recordData) == 0) {
+			throw new t3lib_file_exception_FileNotFound();
+		}
+
+		return new t3lib_file_File($recordData[0]);
+	}
+
+	/**
+	 * Returns a file object by the file's complete path.
+	 *
+	 * @static
+	 * @throws t3lib_file_exception_FileNotFound
+	 * @param  string  $filePath
+	 * @return t3lib_file_File
+	 */
+	public static function getByFilepath($filePath) {
+		$fileName = substr($filePath, strrpos($filePath, '/') + 1);
+		$folderPath = substr($filePath, 0, strrpos($filePath, '/') + 1);
+
+		$recordData = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*', 'sys_files',
+			'file_path = "' . $folderPath . '" AND file_name = "' . $fileName . '"');
+
+		if (count($recordData) == 0) {
+			throw new t3lib_file_exception_FileNotFound();
+		}
+
+		return new t3lib_file_File($recordData[0]);
+	}
+
+	public static function getAllInPath($path) {
+		$recordData = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*', 'sys_files',
+			'file_path = "' . $path . '"');
+
+		if (count($recordData) == 0) {
+			throw new t3lib_file_exception_FileNotFound();
+		}
+
+		foreach ($recordData as $record) {
+			$fileObjects[] = new t3lib_file_File($record); 
+		}
+
+		return $fileObjects;
+	}
+}
+
+?>
\ No newline at end of file
